> For the complete documentation index, see [llms.txt](https://docs.yarnspinner.dev/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.yarnspinner.dev/3.1/api/csharp/yarn.compiler/yarn.compiler.declaration/yarn.compiler.declaration.createvariable.md).

# CreateVariable(string,IType,IConvertible,string?)

Method in [Declaration](/3.1/api/csharp/yarn.compiler/yarn.compiler.declaration.md)

## Summary

Creates a new instance of the [Declaration](/3.1/api/csharp/yarn.compiler/yarn.compiler.declaration.md) class, using the given name, type and default value.

```csharp
public static Declaration CreateVariable(string name, IType type, IConvertible defaultValue, string? description = null)
```

## Parameters

| Name                                                  | Description                                                                                                          |
| ----------------------------------------------------- | -------------------------------------------------------------------------------------------------------------------- |
| `string` name                                         | The name of the new declaration.                                                                                     |
| [Yarn.IType](/3.1/api/csharp/yarn/yarn.itype.md) type | The type of the declaration.                                                                                         |
| `System.IConvertible` defaultValue                    | The default value of the declaration. This must be a string, a number (integer or floating-point), or boolean value. |
| `string` description                                  | The description of the new declaration.                                                                              |

## Returns

A new instance of the [Declaration](/3.1/api/csharp/yarn.compiler/yarn.compiler.declaration.md) class.


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.yarnspinner.dev/3.1/api/csharp/yarn.compiler/yarn.compiler.declaration/yarn.compiler.declaration.createvariable.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
